wayland::server::shell_surface_t(3)

NAME
wayland::server::shell_surface_t - desktop-style metadata interface

SYNOPSIS

#include <wayland-server-protocol.hpp>

Inherits wayland::server::resource_t.

  Public Member Functions

std::function< void(uint32_t)> & on_pong ()
respond to a ping event
std::function< void(seat_t, uint32_t)> & on_move ()
start an interactive move
std::function< void(seat_t, uint32_t, shell_surface_resize)> & on_resize ()
start an interactive resize
std::function< void()> & on_set_toplevel ()
make the surface a toplevel surface
std::function< void(surface_t, int32_t, int32_t, shell_surface_transient)> & on_set_transient ()
make the surface a transient surface
std::function< void(shell_surface_fullscreen_method, uint32_t, output_t)> & on_set_fullscreen ()
make the surface a fullscreen surface
std::function< void(seat_t, uint32_t, surface_t, int32_t, int32_t, shell_surface_transient)> & on_set_popup ()
make the surface a popup surface
std::function< void(output_t)> & on_set_maximized ()
make the surface a maximized surface
std::function< void(std::string)> & on_set_title ()
set surface title
std::function< void(std::string)> & on_set_class ()
set surface class
void ping (uint32_t serial, bool post=true)
ping client
void configure (shell_surface_resize const &edges, int32_t width, int32_t height, bool post=true)
suggest resize
void popup_done (bool post=true)
popup interaction is done
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
void post_no_memory () const
uint32_t get_id () const
client_t get_client () const
unsigned int get_version () const
std::string get_class ()

  Static Public Attributes

static constexpr std::uint32_t ping_since_version = 1
Minimum protocol version required for the ping function.
static constexpr std::uint32_t configure_since_version = 1
Minimum protocol version required for the configure function.
static constexpr std::uint32_t popup_done_since_version = 1
Minimum protocol version required for the popup_done function.

Detailed Description

desktop-style metadata interface

An interface that may be implemented by a wl_surface, for implementations that provide a desktop-style user interface.

It provides requests to treat surfaces like toplevel, fullscreen or popup windows, move, resize or maximize them, associate metadata like title and class, etc.

On the server side the object is automatically destroyed when the related wl_surface is destroyed. On the client side, wl_shell_surface_destroy() must be called before destroying the wl_surface object.

Definition at line 1740 of file wayland-server-protocol.hpp.

Member Function Documentation

  void shell_surface_t::configure (shell_surface_resize const & edges, int32_t width, int32_t height, bool post = true)

suggest resize

Parameters
    edges how the surface was resized
    width new width of the surface
    height new height of the surface

The configure event asks the client to resize its surface.

The size is a hint, in the sense that the client is free to ignore it if it doesn't resize, pick a smaller size (to satisfy aspect ratio or resize in steps of NxM pixels).

The edges parameter provides a hint about how the surface was resized. The client may use this information to decide how to adjust its content to the new size (e.g. a scrolling area might adjust its content position to leave the viewable content unmoved).

The client is free to dismiss all but the last configure event it received.

The width and height arguments specify the size of the window in surface-local coordinates.

Definition at line 2328 of file wayland-server-protocol.cpp.

  std::string wayland::server::resource_t::get_class () [inherited]
Retrieve the interface name (class) of a resource object.

Returns
    Interface name of the resource object.

  client_t wayland::server::resource_t::get_client () const [inherited]
Get the associated client

Returns
    the client that owns the resource.

  uint32_t wayland::server::resource_t::get_id () const [inherited]
Get the internal ID of the resource

Returns
    the internal ID of the resource

  unsigned int wayland::server::resource_t::get_version () const [inherited]
Get interface version

Returns
    Interface version this resource has been constructed with.

  std::function< void(seat_t, uint32_t)> & shell_surface_t::on_move ()

start an interactive move

Parameters
    seat seat whose pointer is used
    serial serial number of the implicit grab on the pointer

Start a pointer-driven move of the surface.

This request must be used in response to a button press event. The server may ignore move requests depending on the state of the surface (e.g. fullscreen or maximized).

Definition at line 2269 of file wayland-server-protocol.cpp.

  std::function< void(uint32_t)> & shell_surface_t::on_pong ()

respond to a ping event

Parameters
    serial serial number of the ping event

A client must respond to a ping event with a pong request or the client may be deemed unresponsive.

Definition at line 2263 of file wayland-server-protocol.cpp.

  std::function< void(seat_t, uint32_t, shell_surface_resize)> & shell_surface_t::on_resize ()

start an interactive resize

Parameters
    seat seat whose pointer is used
    serial serial number of the implicit grab on the pointer
    edges which edge or corner is being dragged

Start a pointer-driven resizing of the surface.

This request must be used in response to a button press event. The server may ignore resize requests depending on the state of the surface (e.g. fullscreen or maximized).

Definition at line 2275 of file wayland-server-protocol.cpp.

  std::function< void(std::string)> & shell_surface_t::on_set_class ()

set surface class

Parameters
    class_ surface class

Set a class for the surface.

The surface class identifies the general class of applications to which the surface belongs. A common convention is to use the file name (or the full path if it is a non-standard location) of the application's .desktop file as the class.

Definition at line 2317 of file wayland-server-protocol.cpp.

  std::function< void(shell_surface_fullscreen_method, uint32_t, output_t)> & shell_surface_t::on_set_fullscreen ()

make the surface a fullscreen surface

Parameters
    method method for resolving size conflict
    framerate framerate in mHz
    output output on which the surface is to be fullscreen

Map the surface as a fullscreen surface.

If an output parameter is given then the surface will be made fullscreen on that output. If the client does not specify the output then the compositor will apply its policy - usually choosing the output on which the surface has the biggest surface area.

The client may specify a method to resolve a size conflict between the output size and the surface size - this is provided through the method parameter.

The framerate parameter is used only when the method is set to 'driver', to indicate the preferred framerate. A value of 0 indicates that the client does not care about framerate. The framerate is specified in mHz, that is framerate of 60000 is 60Hz.

A method of 'scale' or 'driver' implies a scaling operation of the surface, either via a direct scaling operation or a change of the output mode. This will override any kind of output scaling, so that mapping a surface with a buffer size equal to the mode can fill the screen independent of buffer_scale.

A method of 'fill' means we don't scale up the buffer, however any output scale is applied. This means that you may run into an edge case where the application maps a buffer with the same size of the output mode but buffer_scale 1 (thus making a surface larger than the output). In this case it is allowed to downscale the results to fit the screen.

The compositor must reply to this request with a configure event with the dimensions for the output on which the surface will be made fullscreen.

Definition at line 2293 of file wayland-server-protocol.cpp.

  std::function< void(output_t)> & shell_surface_t::on_set_maximized ()

make the surface a maximized surface

Parameters
    output output on which the surface is to be maximized

Map the surface as a maximized surface.

If an output parameter is given then the surface will be maximized on that output. If the client does not specify the output then the compositor will apply its policy - usually choosing the output on which the surface has the biggest surface area.

The compositor will reply with a configure event telling the expected new surface size. The operation is completed on the next buffer attach to this surface.

A maximized surface typically fills the entire output it is bound to, except for desktop elements such as panels. This is the main difference between a maximized shell surface and a fullscreen shell surface.

The details depend on the compositor implementation.

Definition at line 2305 of file wayland-server-protocol.cpp.

  std::function< void(seat_t, uint32_t, surface_t, int32_t, int32_t, shell_surface_transient)> & shell_surface_t::on_set_popup ()

make the surface a popup surface

Parameters
    seat seat whose pointer is used
    serial serial number of the implicit grab on the pointer
    parent parent surface
    x surface-local x coordinate
    y surface-local y coordinate
    flags transient surface behavior

Map the surface as a popup.

A popup surface is a transient surface with an added pointer grab.

An existing implicit grab will be changed to owner-events mode, and the popup grab will continue after the implicit grab ends (i.e. releasing the mouse button does not cause the popup to be unmapped).

The popup grab continues until the window is destroyed or a mouse button is pressed in any other client's window. A click in any of the client's surfaces is reported as normal, however, clicks in other clients' surfaces will be discarded and trigger the callback.

The x and y arguments specify the location of the upper left corner of the surface relative to the upper left corner of the parent surface, in surface-local coordinates.

Definition at line 2299 of file wayland-server-protocol.cpp.

  std::function< void(std::string)> & shell_surface_t::on_set_title ()

set surface title

Parameters
    title surface title

Set a short title for the surface.

This string may be used to identify the surface in a task bar, window list, or other user interface elements provided by the compositor.

The string must be encoded in UTF-8.

Definition at line 2311 of file wayland-server-protocol.cpp.

  std::function< void()> & shell_surface_t::on_set_toplevel ()

make the surface a toplevel surface Map the surface as a toplevel surface.

A toplevel surface is not fullscreen, maximized or transient.

Definition at line 2281 of file wayland-server-protocol.cpp.

  std::function< void(surface_t, int32_t, int32_t, shell_surface_transient)> & shell_surface_t::on_set_transient ()

make the surface a transient surface

Parameters
    parent parent surface
    x surface-local x coordinate
    y surface-local y coordinate
    flags transient surface behavior

Map the surface relative to an existing surface.

The x and y arguments specify the location of the upper left corner of the surface relative to the upper left corner of the parent surface, in surface-local coordinates.

The flags argument controls details of the transient behaviour.

Definition at line 2287 of file wayland-server-protocol.cpp.

  void shell_surface_t::ping (uint32_t serial, bool post = true)

ping client

Parameters
    serial serial number of the ping

Ping a client to check if it is receiving events and sending requests. A client is expected to reply with a pong request.

Definition at line 2323 of file wayland-server-protocol.cpp.

  void shell_surface_t::popup_done (bool post = true)

popup interaction is done The popup_done event is sent out when a popup grab is broken, that is, when the user clicks a surface that doesn't belong to the client owning the popup surface.

Definition at line 2333 of file wayland-server-protocol.cpp.

  void wayland::server::resource_t::post_no_memory () const [inherited]
Post 'not enough memory' error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

  bool wayland::server::resource_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

Member Data Documentation

  constexpr std::uint32_t wayland::server::shell_surface_t::configure_since_version = 1 [static], [constexpr]

Minimum protocol version required for the configure function.

Definition at line 2003 of file wayland-server-protocol.hpp.

  constexpr std::uint32_t wayland::server::shell_surface_t::ping_since_version = 1 [static], [constexpr]

Minimum protocol version required for the ping function.

Definition at line 1973 of file wayland-server-protocol.hpp.

  constexpr std::uint32_t wayland::server::shell_surface_t::popup_done_since_version = 1 [static], [constexpr]

Minimum protocol version required for the popup_done function.

Definition at line 2016 of file wayland-server-protocol.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.